diff --git a/web/config.py b/web/config.py
index 2643ef19..002a9951 100644
--- a/web/config.py
+++ b/web/config.py
@@ -156,8 +156,8 @@ X_FRAME_OPTIONS = "SAMEORIGIN"
 # such as JavaScript, CSS, or pretty much anything that the browser loads.
 # see https://content-security-policy.com/#source_list for more info
 # e.g. "default-src https: data: 'unsafe-inline' 'unsafe-eval';"
-CONTENT_SECURITY_POLICY = "default-src http: data: blob: 'unsafe-inline' " \
-                          "'unsafe-eval';"
+CONTENT_SECURITY_POLICY = "default-src ws: http: data: blob: 'unsafe-inline'" \
+                          " 'unsafe-eval';"
 
 # STRICT_TRANSPORT_SECURITY_ENABLED when set to True will set the
 # Strict-Transport-Security header
@@ -636,6 +636,19 @@ KRB_AUTO_CREATE_USER = True
 
 KERBEROS_CCACHE_DIR = os.path.join(DATA_DIR, 'krbccache')
 
+# PSQL tool settings
+# This will enable PSQL tool in pgAdmin. So user can execute the commands using
+# PSQL terminal in pgAdmin.
+ENABLE_PSQL = True
+
+# ALLOW_PSQL_SHELL_COMMAND = True will disable the execution of os level
+# commands using meta command \! from PSQL terminal.
+# As PSQL allow user to execute the os level commands from the PSQL terminal
+# user can execute any system level command as per the system login user
+# privileges. Default this setting is set to False but if it set to True
+# User will able to execute the system level commands through PSQL terminal in
+# pgAdmin.
+ALLOW_PSQL_SHELL_COMMANDS = False
 
 ##########################################################################
 # Local config settings
diff --git a/web/pgAdmin4.py b/web/pgAdmin4.py
index d2bd1af6..dc1924cb 100644
--- a/web/pgAdmin4.py
+++ b/web/pgAdmin4.py
@@ -13,7 +13,7 @@ to start a web server."""
 
 
 import sys
-from cheroot.wsgi import Server as CherootServer
+
 
 if sys.version_info < (3, 4):
     raise RuntimeError('This application must be run under Python 3.4 '
@@ -37,7 +37,7 @@ else:
     builtins.SERVER_MODE = None
 
 import config
-from pgadmin import create_app
+from pgadmin import create_app, socketio
 from pgadmin.utils import u_encode, fs_encoding, file_quote
 from pgadmin.utils.constants import INTERNAL
 # Get the config database schema version. We store this in pgadmin.model
@@ -97,6 +97,8 @@ if not os.path.isfile(config.SQLITE_PATH):
 ##########################################################################
 app = create_app()
 app.debug = False
+app.config['sessions'] = dict()
+
 if config.SERVER_MODE:
     app.wsgi_app = ReverseProxied(app.wsgi_app)
 
@@ -206,17 +208,16 @@ def main():
         else:
             # Can use cheroot instead of flask dev server when not in debug
             # 10 is default thread count in CherootServer
-            num_threads = 10 if config.THREADED_MODE else 1
-            prod_server = CherootServer(
-                (config.DEFAULT_SERVER, config.EFFECTIVE_SERVER_PORT),
-                wsgi_app=app,
-                numthreads=num_threads,
-                server_name=config.APP_NAME)
+            # num_threads = 10 if config.THREADED_MODE else 1
             try:
-                print("Using production server...")
-                prod_server.start()
+                socketio.run(
+                    app,
+                    host=config.DEFAULT_SERVER,
+                    port=config.EFFECTIVE_SERVER_PORT,
+                )
             except KeyboardInterrupt:
-                prod_server.stop()
+                print("CLOSE SERVER")
+                socketio.stop()
 
     except IOError:
         app.logger.error("Error starting the app server: %s", sys.exc_info())
diff --git a/web/pgadmin/__init__.py b/web/pgadmin/__init__.py
index a7333537..fad91082 100644
--- a/web/pgadmin/__init__.py
+++ b/web/pgadmin/__init__.py
@@ -19,6 +19,7 @@ from collections import defaultdict
 from importlib import import_module
 
 from flask import Flask, abort, request, current_app, session, url_for
+from flask_socketio import SocketIO
 from werkzeug.exceptions import HTTPException
 from flask_babelex import Babel, gettext
 from flask_babelex import gettext as _
@@ -52,10 +53,15 @@ import mimetypes
 mimetypes.add_type('application/javascript', '.js')
 mimetypes.add_type('text/css', '.css')
 
+
 winreg = None
 if os.name == 'nt':
     import winreg
 
+socketio = SocketIO(manage_session=False, async_mode='eventlet',
+                    logger=False, engineio_logger=False, debug=False,
+                    ping_interval=25, ping_timeout=120)
+
 
 class PgAdmin(Flask):
     def __init__(self, *args, **kwargs):
@@ -811,4 +817,5 @@ def create_app(app_name=None):
     ##########################################################################
     # All done!
     ##########################################################################
+    socketio.init_app(app)
     return app
diff --git a/web/pgadmin/browser/register_browser_preferences.py b/web/pgadmin/browser/register_browser_preferences.py
index 235db027..d835ca82 100644
--- a/web/pgadmin/browser/register_browser_preferences.py
+++ b/web/pgadmin/browser/register_browser_preferences.py
@@ -10,6 +10,7 @@ from flask_babelex import gettext
 from pgadmin.utils.constants import PREF_LABEL_DISPLAY,\
     PREF_LABEL_KEYBOARD_SHORTCUTS, PREF_LABEL_TABS_SETTINGS, \
     PREF_LABEL_OPTIONS
+from flask_security import current_user
 import config
 
 LOCK_LAYOUT_LEVEL = {
@@ -511,10 +512,12 @@ def register_browser_preferences(self):
         options=[{'label': gettext('Query Tool'), 'value': 'qt'},
                  {'label': gettext('Debugger'), 'value': 'debugger'},
                  {'label': gettext('Schema Diff'), 'value': 'schema_diff'},
-                 {'label': gettext('ERD Tool'), 'value': 'erd_tool'}],
-        help_str=gettext('Select Query Tool, Debugger, or Schema Diff from '
-                         'the drop-down to set open in new browser tab for '
-                         'that particular module.'),
+                 {'label': gettext('ERD Tool'), 'value': 'erd_tool'},
+                 {'label': gettext('PSQL Tool'), 'value': 'psql_tool'}],
+        help_str=gettext('Select Query Tool, Debugger, Schema Diff, ERD Tool '
+                         'or PSQL Tool from the drop-down to set '
+                         'open in new browser tab for that particular module.'
+                         ),
         select2={
             'multiple': True, 'allowClear': False,
             'tags': True, 'first_empty': False,
@@ -523,3 +526,16 @@ def register_browser_preferences(self):
             'placeholder': gettext('Select open new tab...')
         }
     )
+
+    self.psql_tab_title = self.preference.register(
+        'tab_settings', 'psql_tab_title_placeholder',
+        gettext("PSQL tool tab title"),
+        'text', '%DATABASE%/%USERNAME%@%SERVER%',
+        category_label=PREF_LABEL_DISPLAY,
+        help_str=gettext(
+            'Supported placeholders are %DATABASE%, %USERNAME%, and %SERVER%. '
+            'Users can provide any string with or without placeholders of'
+            ' their choice. The blank title will be revert back to the'
+            ' default title with placeholders.'
+        )
+    )
diff --git a/web/pgadmin/browser/server_groups/servers/__init__.py b/web/pgadmin/browser/server_groups/servers/__init__.py
index f4165c32..01f83b11 100644
--- a/web/pgadmin/browser/server_groups/servers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/__init__.py
@@ -34,6 +34,7 @@ from pgadmin.utils.constants import UNAUTH_REQ, MIMETYPE_APP_JS, \
     SERVER_CONNECTION_CLOSED
 from sqlalchemy import or_
 from pgadmin.utils.preferences import Preferences
+from .... import socketio as sio
 
 
 def has_any(data, keys):
@@ -1499,6 +1500,13 @@ class ServerNode(PGChildNodeView):
 
         # Release Connection
         manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(sid)
+        # Check if any psql terminal is running for the current disconnecting
+        # server. If any terminate the psql tool connection.
+        if 'sid_soid_mapping' in current_app.config and sid in \
+                current_app.config['sid_soid_mapping']:
+            if sid in current_app.config['sid_soid_mapping']:
+                for i in current_app.config['sid_soid_mapping'][sid]:
+                    sio.emit('disconnect-psql', namespace='/pty', to=i)
 
         status = manager.release()
 
diff --git a/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js b/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
index 01ab89c5..eb20cac5 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
@@ -122,6 +122,9 @@ define('pgadmin.node.database', [
       is_connected: function(node) {
         return (node && node.connected == true && node.canDisconn == true);
       },
+      is_psql_enabled: function(node) {
+        return (node && node.connected == true) && pgAdmin['enable_psql'];
+      },
       is_conn_allow: function(node) {
         return (node && node.allowConn == true);
       },
diff --git a/web/pgadmin/browser/server_groups/servers/static/js/server.js b/web/pgadmin/browser/server_groups/servers/static/js/server.js
index 45dea090..3fb1e7d7 100644
--- a/web/pgadmin/browser/server_groups/servers/static/js/server.js
+++ b/web/pgadmin/browser/server_groups/servers/static/js/server.js
@@ -102,6 +102,12 @@ define('pgadmin.node.server', [
             data_disabled: gettext('Database is already disconnected.'),
           },
         },{
+          name: 'server_psql', node: 'server', module: this,
+          applies: ['object', 'context'], callback: 'server_psql_tool',
+          category: 'psql_tool', priority: 5, label: gettext('PSQL Tool (Beta)'),
+          enable : 'is_psql_enabled',
+        },
+        {
           name: 'reload_configuration', node: 'server', module: this,
           applies: ['tools', 'context'], callback: 'reload_configuration',
           category: 'reload', priority: 6, label: gettext('Reload Configuration'),
@@ -183,6 +189,9 @@ define('pgadmin.node.server', [
       is_connected: function(node) {
         return (node && node.connected == true);
       },
+      is_psql_enabled: function(node) {
+        return (node && node.connected == true) && pgAdmin['enable_psql'];
+      },
       enable_reload_config: function(node) {
         // Must be connected & is Super user
         if (node && node._type == 'server' &&
@@ -728,6 +737,14 @@ define('pgadmin.node.server', [
 
           return false;
         },
+        /* Open psql tool for server*/
+        server_psql_tool: function(args) {
+          var input = args || {},
+            t = pgBrowser.tree,
+            i = input.item || t.selected(),
+            d = i && i.length == 1 ? t.itemData(i) : undefined;
+          pgBrowser.psql.psql_tool(d, i, true);
+        }
       },
       model: pgAdmin.Browser.Node.Model.extend({
         defaults: {
diff --git a/web/pgadmin/browser/static/js/collection.js b/web/pgadmin/browser/static/js/collection.js
index 3823ef35..e763aa11 100644
--- a/web/pgadmin/browser/static/js/collection.js
+++ b/web/pgadmin/browser/static/js/collection.js
@@ -64,6 +64,14 @@ define([
               priority: 997, label: gettext('Search Objects...'),
               icon: 'fa fa-search',
             }]);
+
+            // show psql tool same as query tool.
+            pgAdmin.Browser.add_menus([{
+              name: 'show_psql_tool', node: this.type, module: this,
+              applies: ['context'], callback: 'show_psql_tool',
+              priority: 998, label: gettext('PSQL Tool (Beta)'),
+              icon: 'fas fa-terminal',
+            }]);
           }
         }
       },
@@ -498,6 +506,13 @@ define([
           pgAdmin.SearchObjects.show_search_objects('', pgAdmin.Browser.tree.selected());
         }
       },
+      show_psql_tool: function(args) {
+        var input = args || {},
+          t = pgBrowser.tree,
+          i = input.item || t.selected(),
+          d = i && i.length == 1 ? t.itemData(i) : undefined;
+        pgBrowser.psql.psql_tool(d, i, true);
+      },
     });
 
   return pgBrowser.Collection;
diff --git a/web/pgadmin/browser/static/js/node.js b/web/pgadmin/browser/static/js/node.js
index 1c5af3f5..23585dbe 100644
--- a/web/pgadmin/browser/static/js/node.js
+++ b/web/pgadmin/browser/static/js/node.js
@@ -209,6 +209,14 @@ define('pgadmin.browser.node', [
           priority: 997, label: gettext('Search Objects...'),
           icon: 'fa fa-search', enable: enable,
         }]);
+
+        // show psql tool same as query tool.
+        pgAdmin.Browser.add_menus([{
+          name: 'show_psql_tool', node: this.type, module: this,
+          applies: ['context'], callback: 'show_psql_tool',
+          priority: 998, label: gettext('PSQL Tool (Beta)'),
+          icon: 'fas fa-terminal',
+        }]);
       }
 
       // This will add options of scripts eg:'CREATE Script'
@@ -902,6 +910,15 @@ define('pgadmin.browser.node', [
         pgAdmin.DataGrid.show_query_tool('', i);
       },
 
+      // Callback to render psql tool.
+      show_psql_tool: function(args) {
+        var input = args || {},
+          t = pgBrowser.tree,
+          i = input.item || t.selected(),
+          d = i && i.length == 1 ? t.itemData(i) : undefined;
+        pgBrowser.psql.psql_tool(d, i, true);
+      },
+
       // Logic to change the server background colour
       // There is no way of applying CSS to parent element so we have to
       // do it via JS code only
diff --git a/web/pgadmin/browser/static/js/panel.js b/web/pgadmin/browser/static/js/panel.js
index c9e64132..3068aabe 100644
--- a/web/pgadmin/browser/static/js/panel.js
+++ b/web/pgadmin/browser/static/js/panel.js
@@ -122,10 +122,30 @@ define(
                     myPanel.on(ev, that.handleVisibility.bind(myPanel, ev));
                   });
               }
+
+              // Listen on detach panel event
+              myPanel.on(wcDocker.EVENT.DETACHED, function(obj) {
+                that.setCodeMirrorHeight(obj);
+              });
             },
           });
         }
       },
+      setCodeMirrorHeight: function() {
+        // Fix for mac os code-mirror showing black screen.
+        var txtArea = $('.pg-panel-content .sql_textarea > textarea').first();
+        txtArea.css('z-index', -1);
+        var $tabContent = $('.pg-panel-content > .sql_textarea').first();
+        var $sqlPane = $tabContent.find('.CodeMirror > div > textarea');
+        for(let i=0; i<$sqlPane.length; i++) {$($sqlPane[i]).css('z-index', -1);}
+
+        $tabContent = $('.pg-panel-content > .sql_textarea').first();
+        $sqlPane = $tabContent.find('.pg-panel-content');
+        $sqlPane.find('.CodeMirror').css(
+          'cssText',
+          'height: ' + ($tabContent.height()) + 'px !important;'
+        );
+      },
       eventFunc: function(eventName) {
         var name = $(this).data('pgAdminName');
 
diff --git a/web/pgadmin/browser/static/js/toolbar.js b/web/pgadmin/browser/static/js/toolbar.js
index 09baaf22..90d2d007 100644
--- a/web/pgadmin/browser/static/js/toolbar.js
+++ b/web/pgadmin/browser/static/js/toolbar.js
@@ -56,6 +56,15 @@ let _defaultToolBarButtons = [
     toggleClass: '',
     parentClass: 'pg-toolbar-btn btn-primary-icon',
     enabled: false,
+  },{
+    label: gettext('PSQL Tool'),
+    ariaLabel: gettext('PSQL Tool'),
+    btnClass: 'fas fa-terminal',
+    text: '',
+    toggled: false,
+    toggleClass: '',
+    parentClass: 'pg-toolbar-btn btn-primary-icon pg-toolbar-psql',
+    enabled: false,
   },
 ];
 
@@ -105,6 +114,13 @@ export function initializeToolbar(panel, wcDocker) {
       pgAdmin.DataGrid.show_filtered_row({mnuid: 4}, pgAdmin.Browser.tree.selected());
     else if ('name' in data && data.name === gettext('Search objects'))
       pgAdmin.SearchObjects.show_search_objects('', pgAdmin.Browser.tree.selected());
+    else if ('name' in data && data.name === gettext('PSQL Tool')){
+      var input = {},
+        t = pgAdmin.Browser.tree,
+        i = input.item || t.selected(),
+        d = i && i.length == 1 ? t.itemData(i) : undefined;
+      pgAdmin.Browser.psql.psql_tool(d, i, true);
+    }
   });
 }
 
diff --git a/web/pgadmin/static/bundle/browser.js b/web/pgadmin/static/bundle/browser.js
index 14140a2f..0b3ad81b 100644
--- a/web/pgadmin/static/bundle/browser.js
+++ b/web/pgadmin/static/bundle/browser.js
@@ -11,6 +11,7 @@ define('bundled_browser',[
   'pgadmin.browser',
   'sources/browser/index',
   'top/tools/erd/static/js/index',
+  'top/tools/psql/static/js/index',
 ], function(pgBrowser) {
   pgBrowser.init();
 });
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js b/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
index 1348cc45..42efc04d 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
@@ -100,6 +100,10 @@ export function generateTitle(title_placeholder, title_data) {
     title_placeholder = title_placeholder.replace(new RegExp('%ARGS%'), _.unescape(title_data.args));
     title_placeholder = title_placeholder.replace(new RegExp('%SCHEMA%'), _.unescape(title_data.schema));
     title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
+  } else if(title_data.type == 'psql_tool') {
+    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
+    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
+    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
   }
 
   return _.escape(title_placeholder);
